"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => createPxToVwVisitor
});
module.exports = __toCommonJS(src_exports);

// src/visitor.ts
var baseOptions = {
  designWidth: 320,
  minPixelValue: 1,
  excludeSelectors: []
};
function createExcludeFilter(excludes) {
  const isExclude = (testItem) => {
    if (!testItem.name) {
      return false;
    }
    for (const rule of excludes) {
      if (testItem.type === rule.type) {
        if (typeof rule.name === "string" && rule.name === testItem.name) {
          return true;
        }
        if (typeof rule.name === "object" && rule.name.test(testItem.name)) {
          return true;
        }
      }
    }
    return false;
  };
  return isExclude;
}
function createPxToVwVisitor(userOptions = {}) {
  const options = Object.assign(baseOptions, userOptions);
  const isExclude = createExcludeFilter(options.excludeSelectors);
  let skipCurrentSelector = false;
  return {
    Selector(selectors) {
      skipCurrentSelector = false;
      for (const selector of selectors) {
        if (isExclude(selector)) {
          skipCurrentSelector = true;
        }
      }
    },
    Length(length) {
      if (length.unit === "px" && !skipCurrentSelector) {
        if (length.value > options.minPixelValue) {
          return {
            unit: "vw",
            value: length.value / options.designWidth * 100
          };
        }
      }
    }
  };
}
